unit DockTree;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ImgList, NewDockManager;

type
  TFormDockTree = class(TForm)
    TreeView1: TTreeView;
    ImageList1: TImageList;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormDockTree: TFormDockTree;

implementation

{$R *.DFM}

uses DockHost;

procedure TFormDockTree.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   FormDockHost.DockPanel.OnDockOver := nil;
   FormDockHost.DockPanel.OnUnDock := nil;
   DockHost.NoDockTree := true;
   Action := caFree;
end;

procedure TFormDockTree.FormCreate(Sender: TObject);
begin
  Caption := Name;
end;

procedure TFormDockTree.TreeView1DblClick(Sender: TObject);
var AZone : TNewDockZone;
    Node : TTreeNode;

   function ZAlign( TheZone : TNewDockZone ) : string;
   begin
      Result := 'Unknown';
      Case TheZone.Orientation of
        doNoOrient : Result := 'No Orientation';
        doHorizontal : Result := 'Horizontal';
        doVertical: Result := 'Vertical';
      end;
   end;

   function ChildName( TheZone : TNewDockZone ) : string;
   begin
      Result := '<none>';
      if TheZone.ChildControl <> nil then Result := TheZone.ChildControl.Name;
   end;

   function YesNo( AnObject : TObject ) : string;
   begin
      if assigned( AnObject ) then Result := 'Yes'
                              else Result := 'No';
   end;

begin
   Node := TreeView1.Selected;
   if ( Node <> nil ) and not
      ( FormDockHost.mpDockManager1.LoadingProperties ) then
   begin
      AZone := Node.Data;
      if AZone <> nil then
      begin
         ShowMessage(
                      'Zone align    : ' + ZAlign( AZone ) + #13 +
                      'Child control : ' + ChildName( AZone ) + #13 +
                      'Has parent    : ' + YesNo( AZone.ParentZone ) + #13 +
                      'Prev sibling  : ' + YesNo( AZone.PrevSibling ) + #13 +
                      'Next sibling  : ' + YesNo( AZone.NextSibling ) + #13 +
                      'Has children  : ' + YesNo( AZone.FirstChildZone )
                      );
      end
      else ShowMessage( 'Zone not defined' );
   end;

end;

end.
